# NGRX-Traits

NGRX Traits is a set of factory functions that dynamically generate actions, effects, reducers needed for common functionality like loading a list of entities, filtering, pagination, sorting. They can be mix and match, so you only use what you need, and you can create your own to for example reuse some business logic across your app.

# Features

- ✅ Reduce boilerplate with generated strongly typed actions, selectors, reducers, and effects.
- ✅ Easily mix with your own actions, selectors, reducers, and effects
- ✅ Create your own traits, to easily reuse business logic
- ✅ Transform any trait config from a global store to a local store bound to a components lifecycle
- ✅ Trait to load and cache entities list
- ✅ Trait to filter remote and locally entities list
- ✅ Trait to sort remote and locally entities list
- ✅ Trait to paginate entities list
- ✅ Trait to add single or multi selection entities list
- ✅ Trait to add crud operations to an entities list
- ✅ Trait to load single entities
- ✅ Trait to reduce boilerplate needed when calling backend apis

# Installation and Usage

`npm install ngrx-traits`

For more documentation go to our [github page](https://github.com/gabrielguerrero/ngrx-traits)
