(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ngrx-traits'), require('@angular/core'), require('@ngrx/effects'), require('@ngrx/store/testing')) :
    typeof define === 'function' && define.amd ? define('ngrx-traits/testing', ['exports', 'ngrx-traits', '@angular/core', '@ngrx/effects', '@ngrx/store/testing'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ngrx-traits'] = global['ngrx-traits'] || {}, global['ngrx-traits'].testing = {}), global['ngrx-traits'], global.ng.core, global.effects, global.testing));
}(this, (function (exports, ngrxTraits, core, effects, testing) { 'use strict';

    /*
     * NOTE: provideMockStore({initialState}) initialState will be ignored with local traits store!
     * Override selectors instead
     *
     * You still need to provideMockStore and provideMockActions
     * */
    function provideMockLocalTraits(_b) {
        var traitFactory = _b.traitFactory, selectors = _b.selectors;
        return [
            { provide: ngrxTraits.DISABLE_LOCAL_TRAIT_EFFECTS, useValue: true },
            {
                provide: effects.EffectSources,
                useValue: {
                    addEffects: function () {
                        return;
                    },
                },
            },
            {
                provide: traitFactory,
                deps: [core.Injector, testing.MockStore],
                useFactory: function (injector, mockStore) {
                    var trait = new traitFactory(injector);
                    if (selectors) {
                        Object.keys(selectors).forEach(function (key) {
                            var _a;
                            return ((_a = trait.localSelectors) === null || _a === void 0 ? void 0 : _a[key]) &&
                                mockStore.overrideSelector(trait.localSelectors[key], selectors === null || selectors === void 0 ? void 0 : selectors[key]);
                        });
                    }
                    return trait;
                },
            },
        ];
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.provideMockLocalTraits = provideMockLocalTraits;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngrx-traits-testing.umd.js.map
