import { DISABLE_LOCAL_TRAIT_EFFECTS, } from 'ngrx-traits';
import { Injector } from '@angular/core';
import { EffectSources } from '@ngrx/effects';
import { MockStore } from '@ngrx/store/testing';
/*
 * NOTE: provideMockStore({initialState}) initialState will be ignored with local traits store!
 * Override selectors instead
 *
 * You still need to provideMockStore and provideMockActions
 * */
export function provideMockLocalTraits({ traitFactory, selectors, }) {
    return [
        { provide: DISABLE_LOCAL_TRAIT_EFFECTS, useValue: true },
        {
            provide: EffectSources,
            useValue: {
                addEffects: () => {
                    return;
                },
            },
        },
        {
            provide: traitFactory,
            deps: [Injector, MockStore],
            useFactory: (injector, mockStore) => {
                const trait = new traitFactory(injector);
                if (selectors) {
                    Object.keys(selectors).forEach((key) => {
                        var _a;
                        return ((_a = trait.localSelectors) === null || _a === void 0 ? void 0 : _a[key]) &&
                            mockStore.overrideSelector(trait.localSelectors[key], selectors === null || selectors === void 0 ? void 0 : selectors[key]);
                    });
                }
                return trait;
            },
        },
    ];
}
//# sourceMappingURL=provide-mock-local-traits.js.map