import { Injectable } from '@angular/core';
import { takeUntil } from 'rxjs/operators';
import { Actions, ofType, } from '@ngrx/effects';
import { Store } from '@ngrx/store';
import * as i0 from "@angular/core";
import * as i1 from "@ngrx/effects";
import * as i2 from "@ngrx/store";
export class TraitEffect {
    constructor(actions$, store) {
        this.actions$ = actions$;
        this.store = store;
        this.name = this.constructor.name;
        this.componentId = '';
    }
    ngrxOnIdentifyEffects() {
        return this.componentId ? this.name + this.componentId : '';
    }
    ngrxOnRunEffects(resolvedEffects$) {
        return this.componentId
            ? resolvedEffects$.pipe(takeUntil(this.actions$.pipe(ofType(getDestroyActionName(this.componentId)))))
            : resolvedEffects$;
    }
}
TraitEffect.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: TraitEffect, deps: [{ token: i1.Actions }, { token: i2.Store }], target: i0.ɵɵFactoryTarget.Injectable });
TraitEffect.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: TraitEffect });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: TraitEffect, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.Actions }, { type: i2.Store }]; } });
export function getDestroyActionName(id) {
    return `[${id}] Destroyed`;
}
//# sourceMappingURL=trait-effect.js.map