import { createAction } from '@ngrx/store';
export function createCrudTraitActions(actionsGroupKey, entitiesName) {
    return {
        addEntities: createAction(`${actionsGroupKey} Add ${entitiesName}`, (...entities) => ({
            entities,
        })),
        removeEntities: createAction(`${actionsGroupKey} Remove ${entitiesName}`, (...keys) => ({
            keys,
        })),
        updateEntities: createAction(`${actionsGroupKey} Update ${entitiesName}`, (...updates) => ({
            updates,
        })),
        upsertEntities: createAction(`${actionsGroupKey} Upsert ${entitiesName}`, (...entities) => ({
            entities,
        })),
        removeAllEntities: createAction(`${actionsGroupKey} Remove All ${entitiesName}`, (predicate) => ({ predicate })),
        clearEntitiesChanges: createAction(`${actionsGroupKey} Clear  ${entitiesName} Changes`),
    };
}
//# sourceMappingURL=crud-entities.trait.actions.js.map