export function createPaginationTraitMutators(allSelectors, allConfigs) {
    const adapter = allConfigs.loadEntities.adapter;
    function mergePaginatedEntities(entities, total = undefined, state) {
        const cacheType = state.pagination.cache.type;
        switch (cacheType) {
            case 'full':
                return adapter.setAll(entities, Object.assign(Object.assign({}, state), { pagination: Object.assign(Object.assign({}, state.pagination), { total: entities.length, cache: Object.assign(Object.assign({}, state.pagination.cache), { start: 0, end: entities.length }) }) }));
            case 'partial': {
                const isPreloadNextPages = state.pagination.currentPage + 1 === state.pagination.requestPage;
                const start = state.pagination.currentPage * state.pagination.pageSize;
                const newEntities = isPreloadNextPages
                    ? [...allSelectors.selectPageEntitiesList(state), ...entities]
                    : entities;
                return adapter.setAll(newEntities, Object.assign(Object.assign({}, state), { pagination: Object.assign(Object.assign({}, state.pagination), { total, cache: Object.assign(Object.assign({}, state.pagination.cache), { start, end: start + entities.length }) }) }));
            }
            case 'grow':
                return adapter.addMany(entities, Object.assign(Object.assign({}, state), { pagination: Object.assign(Object.assign({}, state.pagination), { total, cache: Object.assign(Object.assign({}, state.pagination.cache), { end: state.ids.length + entities.length }) }) }));
        }
        return state;
    }
    return { mergePaginatedEntities };
}
//# sourceMappingURL=entities-pagination.trait.mutators.js.map