import { isFail, isLoading, isSuccess } from './load-entities.utils';
import { createSelector } from '@ngrx/store';
import { selectEntitiesFilter } from '../filter-entities/filter-entities.trait.selectors';
export function createLoadEntitiesTraitSelectors(allConfigs) {
    var _a, _b;
    const adapter = (_a = allConfigs === null || allConfigs === void 0 ? void 0 : allConfigs.loadEntities) === null || _a === void 0 ? void 0 : _a.adapter;
    const entitySelectors = adapter.getSelectors();
    const filterFunction = (_b = allConfigs === null || allConfigs === void 0 ? void 0 : allConfigs.filter) === null || _b === void 0 ? void 0 : _b.filterFn;
    let selectors = {
        selectEntitiesList: entitySelectors.selectAll,
        selectEntitiesMap: entitySelectors.selectEntities,
        selectEntitiesIdsList: entitySelectors.selectIds,
        selectEntitiesTotal: entitySelectors.selectTotal,
        isEntitiesLoadingFail: isFail,
        isEntitiesLoading: isLoading,
        isEntitiesLoadingSuccess: isSuccess,
    };
    if (filterFunction && entitySelectors) {
        const selectEntitiesList = createSelector(entitySelectors.selectAll, selectEntitiesFilter, (entities, filters) => filters ? entities.filter((e) => filterFunction(filters, e)) : entities);
        selectors = Object.assign(Object.assign({}, selectors), { selectEntitiesList, selectEntitiesMap: createSelector(selectors.selectEntitiesMap, selectEntitiesFilter, (entities, filters) => {
                const result = {};
                for (const id in entities) {
                    const e = entities[id];
                    if (filterFunction(filters, e)) {
                        result[id] = e;
                    }
                }
                return result;
            }), selectEntitiesTotal: createSelector(selectEntitiesList, (entities) => entities.length), selectEntitiesIdsList: createSelector(selectEntitiesList, (entities) => entities.map((e) => adapter === null || adapter === void 0 ? void 0 : adapter.selectId(e))) });
    }
    return selectors;
}
//# sourceMappingURL=load-entities.trait.selectors.js.map