import { toMap } from 'ngrx-traits';
import { clearEntitiesSelection, deselectEntities, selectEntities, toggleSelectEntities, } from './select-entities.utils';
export function createSelectEntitiesTraitMutators({ isAllEntitiesSelected, }) {
    function toggleSelectAllEntities(state) {
        const allSelected = isAllEntitiesSelected(state);
        if (allSelected === 'all') {
            return Object.assign(Object.assign({}, state), { selectedIds: {} });
        }
        else {
            return Object.assign(Object.assign({}, state), { selectedIds: toMap(state.ids) });
        }
    }
    return {
        selectEntities,
        deselectEntities,
        toggleSelectEntities,
        toggleSelectAllEntities,
        clearEntitiesSelection,
    };
}
//# sourceMappingURL=select-entities.trait.mutators.js.map