import { insertIf } from 'ngrx-traits';
import { createReducer, on } from '@ngrx/store';
export function createSelectEntitiesInitialState(previousInitialState) {
    return Object.assign(Object.assign({}, previousInitialState), { selectedIds: {} });
}
export function createSelectEntitiesTraitReducer(initialState, allActions, allMutators, allConfigs) {
    var _a, _b;
    const { adapter } = allConfigs.loadEntities;
    const sortRemote = (_a = allConfigs.sort) === null || _a === void 0 ? void 0 : _a.remote;
    const paginationCacheType = (_b = allConfigs.pagination) === null || _b === void 0 ? void 0 : _b.cacheType;
    function updateSelectedIdsChanged(state, updates) {
        const changedIds = updates.reduce((acc, updated) => {
            const id = adapter.selectId(updated.changes);
            if (id && id !== updated.id && state.selectedIds[updated.id] != null) {
                acc.push(updated);
                return acc;
            }
            return acc;
        }, []);
        if (changedIds.length) {
            const selectedIds = Object.assign({}, state.selectedIds);
            changedIds.forEach((updated) => {
                const id = adapter.selectId(updated.changes);
                const value = selectedIds[updated.id];
                delete selectedIds[updated.id];
                selectedIds[id] = value;
            });
            return Object.assign(Object.assign({}, state), { selectedIds });
        }
        return state;
    }
    return createReducer(initialState, on(allActions.selectEntities, (state, { id }) => allMutators.selectEntities(id, state)), on(allActions.deselectEntities, (state, { id }) => allMutators.deselectEntities(id, state)), on(allActions.toggleSelectEntities, (state, { id }) => allMutators.toggleSelectEntities(id, state)), on(allActions.toggleSelectAllEntities, (state) => allMutators.toggleSelectAllEntities(state)), ...insertIf(allActions.removeEntities, () => on(allActions.removeEntities, (state, { keys }) => {
        const selectedIds = Object.assign({}, state.selectedIds);
        keys.forEach((v) => {
            delete selectedIds[v];
        });
        return Object.assign(Object.assign({}, state), { selectedIds });
    })), ...insertIf(allActions.updateEntities, () => on(allActions.updateEntities, (state, { updates }) => updateSelectedIdsChanged(state, updates))), on(allActions.clearEntitiesSelection, (state) => allMutators.clearEntitiesSelection(state)), ...insertIf(allActions.removeAllEntities, () => on(allActions.removeAllEntities, (state) => allMutators.clearEntitiesSelection(state))), ...insertIf(sortRemote, () => on(allActions.sortEntities, (state) => allMutators.clearEntitiesSelection(state))), ...insertIf(allActions.filterEntities, () => on(allActions.filterEntities, (state) => allMutators.clearEntitiesSelection(state))), ...insertIf(!allActions.loadEntitiesPageSuccess, () => on(allActions.loadEntitiesSuccess, (state) => allMutators.clearEntitiesSelection(state))), ...insertIf(!!allActions.loadEntitiesPageSuccess && paginationCacheType === 'partial', () => on(allActions.loadEntitiesPageSuccess, (state) => allMutators.clearEntitiesSelection(state))));
}
//# sourceMappingURL=select-entities.trait.reducer.js.map