import { createSelector } from '@ngrx/store';
import { selectTotalSelectedEntities } from './select-entities.utils';
export function createSelectEntitiesTraitSelectors(previousSelectors) {
    const { selectEntitiesMap, selectEntitiesTotal } = previousSelectors;
    function selectEntitiesIdsSelectedMap(state) {
        return state.selectedIds;
    }
    const selectEntitiesIdsSelectedList = createSelector(selectEntitiesIdsSelectedMap, (ids) => Object.keys(ids));
    const selectEntitiesSelectedMap = createSelector(selectEntitiesIdsSelectedList, selectEntitiesMap, (selectedIds, entities) => selectedIds.reduce((acum, id) => {
        acum[id] = entities[id];
        return acum;
    }, {}));
    const selectEntitiesSelectedList = createSelector(selectEntitiesIdsSelectedList, selectEntitiesMap, (selectedIds, entities) => selectedIds.map((id) => entities[id]));
    const isAllEntitiesSelected = createSelector((state) => selectEntitiesTotal(state), selectTotalSelectedEntities, (total, totalSelected) => totalSelected > 0 && totalSelected === total
        ? 'all'
        : totalSelected === 0
            ? 'none'
            : 'some');
    return {
        selectEntitiesIdsSelectedMap,
        selectEntitiesIdsSelectedList,
        selectEntitiesSelectedMap,
        selectEntitiesSelectedList,
        selectTotalSelectedEntities,
        isAllEntitiesSelected,
    };
}
//# sourceMappingURL=select-entities.trait.selectors.js.map