import { createReducer, on } from '@ngrx/store';
import { insertIf } from 'ngrx-traits';
export function createSelectEntityInitialState(previousInitialState, allConfigs) {
    var _a;
    const selectedId = (_a = allConfigs.singleSelection) === null || _a === void 0 ? void 0 : _a.selectedId;
    return Object.assign(Object.assign({}, previousInitialState), { selectedId });
}
export function createSelectEntityTraitReducer(initialState, allActions, allMutators, allConfigs) {
    var _a, _b;
    const { adapter } = allConfigs.loadEntities;
    const sortRemote = (_a = allConfigs.sort) === null || _a === void 0 ? void 0 : _a.remote;
    const paginationCacheType = (_b = allConfigs.pagination) === null || _b === void 0 ? void 0 : _b.cacheType;
    return createReducer(initialState, on(allActions.selectEntity, (state, { id }) => allMutators.selectEntity(id, state)), on(allActions.deselectEntity, (state) => allMutators.deselectEntity(state)), on(allActions.toggleSelectEntity, (state, { id }) => allMutators.toggleSelectEntity(id, state)), ...insertIf(allActions.removeAllEntities, () => on(allActions.removeAllEntities, (state) => allMutators.deselectEntity(state))), ...insertIf(sortRemote, () => on(allActions.sortEntities, (state) => allMutators.deselectEntity(state))), ...insertIf(allActions.filterEntities, () => on(allActions.filterEntities, (state) => allMutators.deselectEntity(state))), ...insertIf(!allActions.loadEntitiesPageSuccess, () => on(allActions.loadEntitiesSuccess, (state) => allMutators.deselectEntity(state))), ...insertIf(!!allActions.loadEntitiesPageSuccess && paginationCacheType === 'partial', () => on(allActions.loadEntitiesPageSuccess, (state) => allMutators.deselectEntity(state))), ...insertIf(allActions.removeEntities, () => on(allActions.removeEntities, (state, { keys }) => {
        const shouldDeselect = keys.some((v) => v === state.selectedId);
        return shouldDeselect
            ? Object.assign(Object.assign({}, state), { selectedId: undefined }) : state;
    })), ...insertIf(allActions.updateEntities, () => on(allActions.updateEntities, (state, { updates }) => {
        const change = updates.find((updated) => {
            const id = adapter.selectId(updated.changes);
            return id && id !== updated.id && state.selectedId === updated.id;
        });
        return change
            ? Object.assign(Object.assign({}, state), { selectedId: adapter.selectId(change.changes) }) : state;
    })));
}
//# sourceMappingURL=select-entity.trait.reducer.js.map