import { Injectable } from '@angular/core';
import { TraitEffect } from 'ngrx-traits';
import { createEffect, ofType } from '@ngrx/effects';
import { concatMap } from 'rxjs/operators';
import * as i0 from "@angular/core";
export function createSortTraitEffect(allActions, allConfigs) {
    const { remote } = allConfigs.sort;
    class SortEffect extends TraitEffect {
        constructor() {
            super(...arguments);
            this.remoteSort$ = createEffect(() => {
                return this.actions$.pipe(ofType(allActions.sortEntities, allActions.resetEntitiesSort), concatMap(() => allActions.loadEntitiesFirstPage
                    ? [
                        allActions.clearEntitiesPagesCache(),
                        allActions.loadEntitiesFirstPage(),
                    ]
                    : [allActions.loadEntities()]));
            });
        }
    }
    SortEffect.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: SortEffect, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
    SortEffect.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: SortEffect });
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: SortEffect, decorators: [{
                type: Injectable
            }] });
    return remote ? [SortEffect] : [];
}
//# sourceMappingURL=sort-entities.trait.effect.js.map