import { createReducer, on } from '@ngrx/store';
export function createSortInitialState(previousInitialState, allConfigs) {
    const { defaultSort } = allConfigs.sort;
    return Object.assign(Object.assign({}, previousInitialState), { sort: {
            current: defaultSort,
            default: defaultSort,
        } });
}
export function createSortTraitReducer(initialState, allActions, allMutators, allConfigs) {
    const { remote } = allConfigs.sort;
    return createReducer(initialState, on(allActions.sortEntities, (state, { active, direction }) => !remote
        ? allMutators.sortEntities({ active, direction }, state)
        : Object.assign(Object.assign({}, state), { sort: Object.assign(Object.assign({}, state.sort), { current: { active, direction } }) })), on(allActions.resetEntitiesSort, (state) => {
        var _a, _b, _c;
        return ((_a = state.sort) === null || _a === void 0 ? void 0 : _a.default)
            ? !remote
                ? allMutators.sortEntities((_b = state.sort) === null || _b === void 0 ? void 0 : _b.default, state)
                : Object.assign(Object.assign({}, state), { sort: Object.assign(Object.assign({}, state.sort), { current: (_c = state.sort) === null || _c === void 0 ? void 0 : _c.default }) })
            : state;
    }));
}
//# sourceMappingURL=sort-entities.trait.reducer.js.map