import { Injector, OnDestroy } from '@angular/core';
import { EntityFeatureFactory } from '../model';
import { TraitEffect } from '../trait-effect';
import * as i0 from "@angular/core";
export declare function buildLocalTraits<State, F extends EntityFeatureFactory<any, any, State, any, any>>(injector: Injector, componentName: string, traitFactory: F, localEffect?: TraitEffect): {
    destroy: () => void;
} & ReturnType<F>;
export interface Type<T> extends Function {
    new (...args: any[]): T;
}
export interface LocalTraitsConfig<F extends EntityFeatureFactory<any, any>> {
    componentName: string;
    traitsFactory: F;
}
export declare abstract class TraitsLocalStore<F extends EntityFeatureFactory<any, any>> extends TraitEffect implements OnDestroy {
    injector: Injector;
    traits: ReturnType<F> & {
        destroy: () => void;
    };
    localActions: ReturnType<F>['actions'];
    localSelectors: ReturnType<F>['selectors'];
    constructor(injector: Injector);
    abstract setup(): LocalTraitsConfig<F>;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TraitsLocalStore<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TraitsLocalStore<any>>;
}
